#include <bits/stdc++.h>

using namespace std;

unsigned int a[100000];
int cif[30];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < 30; i++)
        cif[i] = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < 30; j++)
            if(a[i]&(1<<j))
                cif[j]++;
    int q;
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        int t;
        cin >> t;
        if(t==0)
        {
            int k;
            cin >> k;
            unsigned int rez = 0;
            for(int j = 0; j < 30; j++)
                if(cif[j]>=k)
                    rez += (1<<j);
            cout << rez << endl;
        }
        else
        {
            int k;
            unsigned int x;
            cin >> k;
            k--;
            cin >> x;
            for(int j = 0; j < 30; j++)
            {
                if(a[k]&(1<<j))
                    cif[j]--;
                if(x&(1<<j))
                    cif[j]++;
            }
            a[k] = x;
        }
    }
    return 0;
}